CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

set(HHVM_DEFINITIONS "HAVE_LIBDL;PHP_MYSQL_UNIX_SOCK_ADDR=\"/var/run/mysqld/mysqld.sock\";HAVE_CURL_MULTI_WAIT;U_USING_ICU_NAMESPACE=1;USE_JEMALLOC=1;NO_TCMALLOC=1;LIBDWARF_CONST_NAME;HAVE_ELF_GETSHDRSTRNDX;HHVM;HAVE_LIBSODIUM;HAVE_FT2BUILD;THRIFT_MUTEX_EMULATE_PTHREAD_TIMEDLOCK;HHVM_DYNAMIC_EXTENSION_DIR=\"/usr/lib64/hhvm/extensions\";_REENTRANT=1;_PTHREADS=1;__STDC_FORMAT_MACROS;_GNU_SOURCE;NDEBUG;ENABLE_FASTCGI=1;HPHP_OSS=1;PACKAGE=hhvm;PACKAGE_VERSION=Release;DEFAULT_CONFIG_DIR=\"/etc/hhvm/\";HAVE_INTTYPES_H;USE_CMAKE;HAVE_LIBGMP;HAVE_LIBINTL;ENABLE_ASYNC_MYSQL=1;HAVE_LIBLDAP;HAVE_LIBICU;HAVE_LIBXML2;HAVE_ICONV;HAVE_LIBICONV;HAVE_LIBEXPAT;HAVE_LIBMAGICKWAND;HAVE_LIBMCRYPT;HAVE_LIBBZIP2;HAVE_LIBMEMCACHED;HAVE_LIBCURL;HAVE_LIBFREETYPE;HAVE_GD_FREETYPE;ENABLE_GD_TTF;HAVE_LIBJPEG;HAVE_GD_JPG;HAVE_LIBPNG;HAVE_GD_PNG;PNG_SKIP_SETJMP_CHECK;HAVE_LIBVPX;HAVE_LIBFRIBIDI;HAVE_LIBGLIB;HAVE_LIBXSLT;FOLLY_HAVE_MALLOC_H=1;FOLLY_NO_CONFIG=1;FOLLY_HAVE_PTHREAD=1;FOLLY_HAVE_CLOCK_GETTIME=1;FOLLY_HAVE_PTHREAD_ATFORK=1;FOLLY_HAVE_PTHREAD_SPINLOCK_T=1;FOLLY_HAVE_FEATURES_H=1;FOLLY_HAVE_LIBDWARF_DWARF_H=0;FOLLY_HAVE_VLA=1;FOLLY_HAVE_IFUNC=0;FOLLY_HAVE_BITS_FUNCTEXCEPT_H=1;FOLLY_HAVE_LINUX_MEMBARRIER_H=1;FOLLY_HAVE_WEAK_SYMBOLS=1;FOLLY_HAVE_MEMRCHR=1;FOLLY_HAVE_PREADV=1;FOLLY_HAVE_PWRITEV=1;FOLLY_HAVE_LIBGFLAGS=0;NO_LIB_GFLAGS")
set(HHVM_VERSION_BRANCH "40800")
set(CMAKE_INSTALL_PREFIX "/usr")
set(CMAKE_INSTALL_LIBDIR "lib64")
set(CMAKE_BUILD_TYPE "Release")

option(HHVM_DSO_TEST_MODE "Build against source headers, not installed ones" Off)
if (HHVM_DSO_TEST_MODE)
  set(HHVM_INCLUDE_DIRS "/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6;/usr/include;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/squangle/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/fb-mysql/src/include;/usr/include/libxml2;/usr/lib64/libzip/include;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/hphp;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/re2/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/libmbfl;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/libmbfl/mbfl;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/libmbfl/filters;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/timelib;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/folly/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/fatal;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/wangle/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/brotli/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/proxygen/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/thrift/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/zstd/src/lib;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/zstd/src/lib/dictBuilder;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/libafdt/src/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/mcrouter/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/fastlz/src;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/double-conversion;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/boost/build/include;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/squangle/src/;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/fb-mysql/src/include/;/usr/include/ImageMagick-6;/usr/include/freetype2;/usr/include/vpx;/usr/include/glib-2.0;/usr/lib64/glib-2.0/include;/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/third-party/folly")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/CMake" "/tmp/slackrepo/SBo/slackrepo.EoLqCK/build_hhvm/hhvm-4.8.6/hphp/public_tld/CMake"
    ${CMAKE_MODULE_PATH})
else()
  set(HHVM_INCLUDE_DIRS "/usr/include;/usr/include;/usr/include/hphp/third-party/squangle/src;/usr/include/hphp/third-party/fb-mysql/src/include;/usr/include/libxml2;/usr/lib64/libzip/include;/usr/include/hphp;/usr/include/hphp/third-party/re2/src;/usr/include/hphp/third-party;/usr/include/hphp/third-party/libmbfl;/usr/include/hphp/third-party/libmbfl/mbfl;/usr/include/hphp/third-party/libmbfl/filters;/usr/include/hphp/third-party/timelib;/usr/include/hphp/third-party/folly/src;/usr/include/hphp/third-party/fatal;/usr/include/hphp/third-party/wangle/src;/usr/include/hphp/third-party/brotli/src;/usr/include/hphp/third-party/proxygen/src;/usr/include/hphp/third-party/thrift/src;/usr/include/hphp/third-party/zstd/src/lib;/usr/include/hphp/third-party/zstd/src/lib/dictBuilder;/usr/include/hphp/third-party/libafdt/src/src;/usr/include/hphp/third-party/mcrouter/src;/usr/include/hphp/third-party/fastlz/src;/usr/include/hphp/third-party/double-conversion;/usr/include/hphp/third-party/boost/build/include;/usr/include/hphp/third-party/squangle/src/;/usr/include/hphp/third-party/fb-mysql/src/include/;/usr/include/ImageMagick-6;/usr/include/freetype2;/usr/include/vpx;/usr/include/glib-2.0;/usr/lib64/glib-2.0/include")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
    ${CMAKE_MODULE_PATH})
endif()

message(STATUS "Configuring for HHVM API version ${HHVM_VERSION_BRANCH}")

include(HPHPFunctions)
include(HPHPIZEFunctions)
include(HPHPCompiler)
include(config)

foreach (dir ${HHVM_INCLUDE_DIRS})
  include_directories(${dir})
endforeach()

add_definitions("-DHHVM_BUILD_DSO")
foreach (def ${HHVM_DEFINITIONS})
  add_definitions("-D${def}")
endforeach()

add_custom_target(test COMMAND
                       HHVM_BIN=${CMAKE_INSTALL_PREFIX}/bin/hhvm
                       ${CMAKE_CURRENT_SOURCE_DIR}/run-test
                       -a "-vDynamicExtensions.99=${EXTENSION_NAME}.so" test
                       DEPENDS ${EXTENSION_NAME})
